#include <iostream>
#include <string>
#include <numeric>

using namespace std;

string f(long long a, long long b) {
    if(gcd(a, b) != 1){
        a /= gcd(a, b);
        b /= gcd(a, b);
        if(gcd(a,b) != 1)
            return "no";
    }
    string ans = "";
    long long l = 0, ld = 1;
    long long r = 1, rd = 0;
    while(true){
        long long m = l + r;
        long long md = ld + rd;
        if(m == a && md == b)
            break;
        if(a * md < b * m){
            ans += 'L';
            r = m;
            rd = md;
        }
        else{
            ans += 'R';
            l = m;
            ld = md;
        }
    }
    return ans;
}

int main() {
    long long a, b;
    cin >> a >> b;
    if(a == 1 && b == 1)
        cout << "R";
    else if(a == 0 && b == 1)
        cout << "no";
    else if(a == 1 && b == 0)
        cout << "no";
    else if(f(a, b) == "no")
            cout << "no";
    else{
        cout << "R" << f(a, b);
    }
}
