#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

void bfs(int p, int ml, const vector<vector<int>> &g, vector<bool> &po){
    queue<int> q;
    vector<int> l;
    q.push(p);
    po[p] = true;
    l.push_back(0);
    while(!q.empty()){
        int c = q.front();
        int cl = l.front();
        q.pop();
        l.erase(l.begin());
        if(cl < ml){
            for(int i = 0; i < g[c].size(); i++) {
                int n = g[c][i];
                if(!po[n]){
                    po[n] = true;
                    q.push(n);
                    l.push_back(cl + 1);
                }
            }
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> g(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<bool> po(n + 1, false);
    for (int i = 0; i < k; i++){
        int p, h;
        cin >> p >> h;
        bfs(p, h, g, po);
    }
    vector<int> ans;
    for(int i = 1; i <= n; i++){
        if(po[i])
            ans.push_back(i);
    }
    cout << ans.size() << endl;
    sort(ans.begin(), ans.end());
    for(int i = 0; i < ans.size(); i++)
        cout << ans[i] << " ";
}
