#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

void bfs(long long p, long long ml, vector<vector<long long>> &g, vector<bool> &po){
    queue<long long> q;
    vector<long long> l;
    q.push(p);
    po[p] = true;
    l.push_back(0);
    while(!q.empty()){
        long long c = q.front();
        long long cl = l.front();
        q.pop();
        l.erase(l.begin());
        if(cl < ml){
            for(long long i = 0; i < g[c].size(); i++) {
                long long n = g[c][i];
                if(!po[n]){
                    po[n] = true;
                    q.push(n);
                    l.push_back(cl + 1);
                }
            }
        }
    }
}

int main() {
    long long n, m, k;
    cin >> n >> m >> k;
    vector<vector<long long>> g(n + 1);
    for(long long i = 0; i < m; i++) {
        long long a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<bool> po(n + 1, false);
    for(long long i = 0; i < k; i++){
        long long p, h;
        cin >> p >> h;
        bfs(p, h, g, po);
    }
    vector<long long> ans;
    for(long long i = 1; i <= n; i++){
        if(po[i])
            ans.push_back(i);
    }
    cout << ans.size() << endl;
    if(!ans.empty()){
        sort(ans.begin(), ans.end());
        for(long long i = 0; i < ans.size(); i++){
            cout << ans[i] << " ";
        }
    }
}
